Codefoces 282E - Sausage Maximization


http://codeforces.com/problemset/problem/282/E
The Bitlandians are quite weird people. They have their own problems and their own solutions. They have their own thoughts and their own beliefs, they have their own values and their own merits. They have their own dishes and their own sausages!
In Bitland a sausage is an array of integers! A sausage's deliciousness is equal to the bitwise excluding OR (the xor operation) of all integers in that sausage.
One day, when Mr. Bitkoch (the local cook) was going to close his BitRestaurant, BitHaval and BitAryo, the most famous citizens of Bitland, entered the restaurant and each ordered a sausage.
But Mr. Bitkoch had only one sausage left. So he decided to cut a prefix (several, may be zero, first array elements) of the sausage and give it to BitHaval and a postfix (several, may be zero, last array elements) of the sausage and give it to BitAryo. Note that one or both pieces of the sausage can be empty. Of course, the cut pieces mustn't intersect (no array element can occur in both pieces).
The pleasure of BitHaval and BitAryo is equal to the bitwise XOR of their sausages' deliciousness. An empty sausage's deliciousness equals zero.
Find a way to cut a piece of sausage for BitHaval and BitAryo that maximizes the pleasure of these worthy citizens.
Input
The first line contains an integer n (1 ≤ n ≤ 105).
The next line contains n integers a1, a2, ..., an (0 ≤ ai ≤ 1012) — Mr. Bitkoch's sausage.
Please, do not use the %lld specifier to read or write 64-bit integers in С++. It is preferred to use the cincout streams or the %I64d specifier.
Output
Print a single integer — the maximum pleasure BitHaval and BitAryo can get from the dinner.
Examples
input
Copy
2
1 2
output
Copy
3
input
Copy
3
1 2 3
output
Copy
3
input
Copy
2
1000 1000
output
Copy
1000

https://blog.csdn.net/mengxiang000000/article/details/74149135
给一个长度为n的整数序列,现在要你截取这个序列的一个前缀和一个后缀(前缀和后缀不能相交),使得前缀和后缀的异或值最大。

思路:
贪心去做,对于每个查询,同样处理成35位二进制01字符串,对应进行查询,如果当前位子是0,那么尽量往1那边走,同理,如果当前位子是1,那么尽量往0那边走即可。

那么O(n)建树+查询即可。

https://gist.github.com/phonism/6604961
https://blog.csdn.net/DOLFAMINGO/article/details/73867435
1.预处理前缀异或、后缀异或。

2.枚举每一个前缀异或(i:0~n):

2.1.将此前缀异或加入到Trie树中,

2.2.根据后一位的后缀异或,在Trie树中查找与之异或后的最大值,并一直更新ans。

学习之处:

当需要在一个序列的中间删除若干个连续元素,使得满足xx条件时:

1.预处理出前缀和、后缀和。

2.枚举每一个前缀和:将此前缀和插入某种数据结构中,再用后一位的后缀和在此数据结构中查找。

类似的题目:http://blog.csdn.net/dolfamingo/article/details/71001021
typedef struct node
{
    struct node *next[2];
}Node, *Trie;

Trie T;
LL n, a[maxn], pre[maxn], rev[maxn];

void init()
{
    scanf("%I64d",&n);
    for(int i = 1; i<=n; i++)
        scanf("%I64d",&a[i]);
    for(int i = 1; i<=n; i++)   //前缀
        pre[i] = pre[i-1]^a[i];
    for(int i = n; i>=1; i--)   //后缀
        rev[i] = rev[i+1]^a[i];

    T = new Node;   //初始化Trie树
    T->next[0] = T->next[1] = NULL;
}

void add(LL x)
{
    Trie p = T;
    for(int i = 50; i>=0; i--)  //从高位到低位
    {
        int d = (x>>i)&1;
        if(p->next[d]==NULL)    //此位的d不存在, 则新建
            p->next[d] = new Node, p->next[d]->next[0] = p->next[d]->next[1] = NULL;
        p = p->next[d];
    }
}

LL query(LL x)
{
    LL tmp = 0;
    Trie p = T;
    for(int i = 50; i>=0; i--)
    {
        //如果!d路存在,则可加上(d ^ !d = 1), 并顺着这条路走下去; 否则走d路(!d路和d路至少一路存在)
        int d = (x>>i)&1;
        if(p->next[!d]) tmp += 1LL*(1LL<<i), p = p->next[!d];
        else p = p->next[d];
    }
    return tmp;
}

void solve()
{
    LL ans = 0;
    for(int i = 0; i<=n; i++) //i为0时, 没有前缀;i为n时,没有后缀。
    {
        add(pre[i]);
        ans = max( ans, query(rev[i+1]) );
    }
    printf("%I64d\n",ans);
}

int main()
{
    init();
    solve();
}
http://www.voidcn.com/article/p-pytyhqxq-wu.html
思路:对于一个后缀,将他前面的所有的前缀加到一个Trie树中,然后根据这个后缀数每个位上的0和1,寻找使其异或最大的数。
如果这种题目没见过类似的话,感觉挺神的,一个长度为 105 的数组,怎么去选前缀和后缀?不过不要惊慌,题目出出来是给我们做的,总有一线生机!
先从最暴力的开始讲起:枚举每一个后缀,让他和所有不与之相交的前缀求异或值,那么转化成了:
       给一个数 a,还有一堆数,怎么在这一堆数中找出一个数 b,a 和 b 的异或值最大?
想想:肯定要先把 a 和这一堆数转化成二进制数,枚举 a 的最高位,要使异或值最大,那么 b 从最高位开始,就要尽量与 a 对应的位不同,对不对?
想到这里,那就好办了:把这一堆数装进一个字典树中,当然,是从最高位开始装,然后就是在这一棵字典树中尽量找出与 a 当前位不同的数,直到找到最低位为止,那么当前路径上经过的数就是我们的数 b 了,a 异或 b 也一定是最大的

上面的问题解决了,这道题也就迎刃而解了:先把所有的数异或起来,作为最初的后缀,而前缀是 0,先插入字典树中,然后,每次将后缀“减一”,前缀“加一”,先把前缀加入字典树中,再在字典树中查询与当前的后缀异或值最大的数
总的时间复杂度 64*n
http://www.voidcn.com/article/p-piuhwttp-hk.html
struct node
{
       int son[2]; 
       ll w;
}p[10000005];
ll a[100005],totol,ans,_2jie[45];
int num;
void InsertToTrie(ll x)
{
       int h=0,i,t;
       for (i=40;i>=0;i--)
       {
             if (x & _2jie[i]) t=1;
                else t=0;
             if (!p[h].son[t]) p[h].son[t]=++num;
             h=p[h].son[t];
       }       
       p[h].w=x;
       return;
}
ll SerchMax(ll x)
{
       int h,i,t;
       h=0;
       for (i=40;i>=0;i--)
       {
             if (x & _2jie[i]) t=1;
                else t=0;
             if (p[h].son[1-t]) h=p[h].son[1-t];
                else h=p[h].son[t]; 
       }
       return p[h].w;
} 
int main()
{
       int i,n;
       ll prefix,postfix; 
       _2jie[0]=1;
       for (i=1;i<=40;i++) _2jie[i]=_2jie[i-1]*2;
       while (~scanf("%d",&n))
       {
             postfix=0;
             for (i=1;i<=n;i++) scanf("%I64d",&a[i]),postfix^=a[i]; 
             memset(p,0,sizeof(p));
             ans=postfix;
             num=0;
             prefix=0;
             InsertToTrie(0);
             for (i=1;i<=n;i++)
             {
                    prefix^=a[i];
                    InsertToTrie(prefix);
                    postfix^=a[i]; 
                    ans=max(ans,SerchMax(postfix)^postfix);
             }
             printf("%I64d\n",ans);    
       }
       return 0;
}



LintCode 762 - Longest Common Subsequence II


Related: Longest Common Subsequence
https://www.lintcode.com/problem/longest-common-subsequence-ii/description
Given two sequence P and Q of numbers. The task is to find Longest Common Subsequence of two sequence if we are allowed to change at most k element in first sequence to any value.

Example

Given P = [8 ,3], Q = [1, 3], K = 1
Return 2
Given P = [1, 2, 3, 4, 5], Q = [5, 3, 1, 4, 2], K = 1
Return 3
https://www.geeksforgeeks.org/longest-common-subsequence-with-at-most-k-changes-allowed/
The idea is to use Dynamic Programming. Define a 3D matrix dp[][][], where dp[i][j][k] defines the Longest Common Subsequence for the first i numbers of first array, first j number of second array when we are allowed to change at max k number in the first array.
Therefore, recursion will look like
If P[i] != Q[j], 
    dp[i][j][k] = max(dp[i - 1][j][k], 
                      dp[i][j - 1][k], 
                      dp[i - 1][j - 1][k - 1] + 1) 
If P[i] == Q[j], 
    dp[i][j][k] = max(dp[i - 1][j][k], 
                      dp[i][j - 1][k], 
                      dp[i - 1][j - 1][k] + 1)
Time Complexity: O(N*M*K).

int lcs(int dp[MAX][MAX][MAX], int arr1[], int n,
                       int arr2[], int m, int k)
{
    // If at most changes is less than 0.
    if (k < 0)
        return -1e7;
  
    // If any of two array is over.
    if (n < 0 || m < 0)
        return 0;
  
    // Making a reference variable to dp[n][m][k]
    int& ans = dp[n][m][k];
  
    // If value is already calculated, return
    // that value.
    if (ans != -1)
        return ans;
  
    // calculating LCS with no changes made.
    ans = max(lcs(dp, arr1, n - 1, arr2, m, k), 
              lcs(dp, arr1, n, arr2, m - 1, k));
  
    // calculating LCS when array element are same.
    if (arr1[n] == arr2[m])
        ans = max(ans, 1 + lcs(dp, arr1, n - 1, 
                                arr2, m - 1, k));
  
    // calculating LCS with changes made.
    ans = max(ans, 1 + lcs(dp, arr1, n - 1, 
                          arr2, m - 1, k - 1));
  
    return ans;
}

https://www.jiuzhang.com/solution/longest-common-subsequence-ii/
最长公共子串的问题是典型的动态规划题,在这里已有题解,就是用二维矩阵来存储所有的中间最佳状态。
这是这个题的变种,因为第一个字符串可以进行k次变动。那么解体就得用三维矩阵来存储中间最佳状态。
而且要把k=0的情况拿出来单独解决。这个k=0的情况实际上就是无变动情形下的解。这个的时间复杂度
是O(mnk),m和n是P和Q字符串的长度,k是P可变换元素数量。
    def longestCommonSubsequence2(self, P, Q, k):
        # Write your code here
        m = len(P)
        n = len(Q)
        l = [[[None for g in range(k+1)] \
        for j in range(n+1)] for i in range(m+1)]
        for i in range(m+1):
            for j in range(n+1):
                if i == 0 or j == 0:
                    l[i][j][0] = 0
                elif P[i-1] == Q[j-1]:
                    l[i][j][0] = l[i-1][j-1][0] + 1
                else:
                    l[i][j][0] = max(l[i-1][j][0], l[i][j-1][0])
        for i in range(m+1):
            for j in range(n+1):
                for g in range(1, k+1):
                    if i == 0  or j == 0:
                        l[i][j][g] = 0
                    elif P[i-1] != Q[j-1]:
                        l[i][j][g] = max(l[i-1][j][g], l[i][j-1][g], l[i-1][j-1][g-1] + 1)
                    else:
                        l[i][j][g] = max(l[i-1][j][g], l[i][j-1][g], l[i-1][j-1][g] + 1)
        return l[m][n][k]

    https://blog.csdn.net/zhaohengchuan/article/details/79703980
    dp[i][j][t]表示P的前i个数字和Q的前j个数字中,在变换了t个元素的情况下,最长公共子序列的长度。初始化之后,对于dp[i][j][t],如果P[i-1]=Q[j-1],由于t表示改变t个元素,dp[i][j][t]可能取dp[i-1][j-1][t]+1,在P[i-1]!=Q[j-1]时,dp[i][j][t]可能取dp[i-1][j-1][t-1]+1(需要改变一个元素)。由于dp[i][j][t]还可能取dp[i-1][j][t]和dp[i][j-1][t],最终结果取最大值。
        int longestCommonSubsequence2(vector<int> &P, vector<int> &Q, int k) {
            // Write your code here
            if (P.empty() || Q.empty() || k < 0)
                return 0;
            int lenp = P.size(), lenq = Q.size();
            //dp[i][j][t]表示P的前i个数字和Q的前j个数字中,在变换了t个元素的情况下,最长公共子序列的长度
            vector<vector<vector<int>>> dp(lenp + 1, vector<vector<int>>(lenq + 1, vector<int>(k + 1)));
            //当i = 0或j = 0时,dp[i][j][t] = 0
            for (int i = 0; i <= lenp; ++i)
            {
                for (int t = 0; t <= k; ++t)
                    dp[i][0][t] = 0;
            }
            for (int j = 0; j <= lenq; ++j)
            {
                for (int t = 0; t <= k; ++t)
                    dp[0][j][t] = 0;
            }
            //处理k=0的情况,类似于公共子序列
            for (int i = 1; i <= lenp; ++i)
            {
                for (int j = 1; j <= lenq; ++j)
                {
                    if (P[i - 1] == Q[j - 1])
                        dp[i][j][0] = dp[i - 1][j - 1][0] + 1;
                    else
                        dp[i][j][0] = maxVal(dp[i - 1][j][0], dp[i][j - 1][0]);
                }
            }
            //若P[i-1]=Q[j-1],不必再变换元素,dp[i][j][t]是dp[i-1][j][t],dp[i][j-1][t],dp[i-1][j-1][t]+1的最大值
            //否则,可能需要变换元素,dp[i][j][t]是dp[i-1][j][t],dp[i][j-1][t],dp[i-1][j-1][t-1]+1的最大值
            for (int i = 1; i <= lenp; ++i)
            {
                for (int j = 1; j <= lenq; ++j)
                {
                    for (int t = 1; t <= k; ++t)
                    {
                        if (P[i - 1] == Q[j - 1])
                            dp[i][j][t] = maxVal(dp[i - 1][j][t], maxVal(dp[i][j - 1][t], dp[i - 1][j - 1][t] + 1));
                        else
                            dp[i][j][t] = maxVal(dp[i - 1][j][t], maxVal(dp[i][j - 1][t], dp[i - 1][j - 1][t - 1] + 1));
                    }
                }
            }
            return dp[lenp][lenq][k];
        }
    https://github.com/jiadaizhao/LintCode/blob/master/0762-Longest%20Common%20Subsequence%20II/0762-Longest%20Common%20Subsequence%20II.cpp
        int longestCommonSubsequence2(vector<int> &P, vector<int> &Q, int k) {
            // Write your code here
            int m = P.size();
            int n = Q.size();
            int dp[1 + k][1 + m][1 + n];
            memset(dp, 0, sizeof(dp));
            for (int i = 1; i <= m; ++i) {
                for (int j = 1; j <= n; ++j) {
                    if (P[i - 1] == Q[j - 1]) {
                        dp[0][i][j] = 1 + dp[0][i - 1][j - 1];
                    }
                    else {
                        dp[0][i][j] = max(dp[0][i - 1][j], dp[0][i][j - 1]);
                    }
                }
            }
         
            for (int l = 1; l <= k; ++l) {
                for (int i = 1; i <= m; ++i) {
                    for (int j = 1; j <= n; ++j) {
                        if (P[i - 1] == Q[j - 1]) {
                            dp[l][i][j] = 1 + dp[l][i - 1][j - 1];
                        }
                        else {
                            dp[l][i][j] = max({dp[l][i - 1][j], dp[l][i][j - 1], 1 + dp[l - 1][i - 1][j - 1]});
                        }
                    }
                }
            }
         
            return dp[k][m][n];
        }




    Labels

    LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

    Popular Posts